import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import { RestGroupCollectionView } from "./rest-group-collection-view";
import { DataType, createElement } from '@mescius/wijmo';
import { FlexGrid } from '@mescius/wijmo.grid';
import { FlexGridFilter } from '@mescius/wijmo.grid.filter';
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let _firstLoad = true;
let cvSettings = {
virtualization: false,
groupLazyLoading: false,
fields: fields,
groupDescriptions: ['State', 'City'],
loading: () => { toggleSpinner(theGrid, true); },
loaded: (s, e) => {
toggleSpinner(theGrid, false);
if (_firstLoad) {
_firstLoad = false;
// select first group row
setTimeout(() => {
theGrid.select(0, 0);
});
}
}
};
// create the grid to show the data
let theGrid = new FlexGrid('#theGrid', {
isReadOnly: true,
autoGenerateColumns: false,
columns: [
{ binding: "OrderId", header: "Order ID" },
{ binding: "StockItem", header: "Stock Item", width: "*", minWidth: 200 },
{ binding: "Color", header: "Color" },
{ binding: "Quantity", header: "Quantity", dataType: DataType.Number, format: 'n0' },
{ binding: "UnitPrice", header: "Unit Price", dataType: DataType.Number, format: 'n2' },
{ binding: "Date", header: "Date", dataType: DataType.Date },
{ binding: "IsChillerStock", header: "Is Chiller Stock", dataType: DataType }
],
//create RestGroupCollectionView instance
//with settings for default server grouping on first load
itemsSource: new RestGroupCollectionView('purchaseorders', cvSettings)
});
// add the filter with Condition filter as default
new FlexGridFilter(theGrid, {
defaultFilterType: 'Condition'
});
document.getElementById("feature-options").addEventListener('click', (e) => {
let element = e.target;
// to avoid click for label
switch (element && element.id) {
case 'groupServer':
cvSettings.virtualization = false;
cvSettings.groupLazyLoading = false;
break;
case 'virtual':
cvSettings.virtualization = true;
cvSettings.groupLazyLoading = false;
break;
case 'lazyload':
cvSettings.virtualization = false;
cvSettings.groupLazyLoading = true;
break;
}
if (element.tagName == "INPUT") {
_firstLoad = true; //reset _firstLoad before CV change
theGrid.itemsSource = new RestGroupCollectionView('purchaseorders', cvSettings);
}
});
}
//show gif loader while data loading
function toggleSpinner(grid, show) {
let _rect = grid.controlRect;
let elem = grid.hostElement.querySelector('.spinner');
if (!elem)
elem = createElement(`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`, grid.hostElement);
elem.style.display = show ? 'block' : 'none';
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js"
integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA=="
crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div id="feature-options">
<label for="groupServer">
<input id="groupServer" type="radio" name="feature" value="groupOnServer" checked> Server Side Grouping
</label>
<br>
<label for="virtual">
<input id="virtual" type="radio" name="feature" value="virtualGrouping"> Server Side Grouping with
virtualization
</label>
<br>
<label for="lazyload">
<input id="lazyload" type="radio" name="feature" value="lazyLoadGrouping"> Server Side Grouping with
group lazy-loading
</label>
</div>
<div id="theGrid"></div>
</div>
</body>
</html>
body {
margin-bottom: 36pt;
margin-top: 10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner {
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top: 40%;
left: 45%;
}
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { DataType, DateTime, httpRequest, copy, changeType, isString, isDate, asNumber, isBoolean, } from '@mescius/wijmo';
import { RestCollectionView } from '@mescius/wijmo.rest';
// limit item count to fetch when virtualization or group lazy-loading is not enabled
const _MAXITEMCOUNT = 10000;
const _TableRecordCount = 231412; // total number of records available in DB for API.
// DataSource API
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestGroupCollectionView extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestGroupCollectionView} class to support ServerSide Grouping.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName, options) {
super(options);
this._url = _apiUrl;
this._pendingRequest = null;
this._tbl = tableName;
this.groupOnServer = true;
copy(this, options);
}
// parse data
_jsonReviver(key, value) {
// regex to parse date
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get request parameters to fetch data based on settings
_getReadParams(item, groupInfo = true, virtualParams = true) {
let gDescs = this.groupDescriptions;
let settings = {};
// #region Only required when ServerAPI limits top to 100 or other value
// load max _MAXITEMCOUNT items when virtualization is not enabled
if (!this.virtualization && this.groupOnServer) {
settings.top = _MAXITEMCOUNT;
}
// all available groups in-case of virtualization
if (this.virtualization && groupInfo && this.groupOnServer) {
settings.top = _MAXITEMCOUNT;
}
// load all available records from table for ServerSide GroupOnly case
if (this.groupOnServer && !this.virtualization && !this.groupLazyLoading && !groupInfo) {
settings.top = _TableRecordCount;
}
// #endRegion
// get filter definition
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
// get groupby defintion
if (this.groupOnServer && gDescs.length > 0) {
// groupby def for groupLazyloading feature
if (this.groupLazyLoading) {
if (item) {
let filters = [];
for (let i = 0; i <= (item.isBottomLevel ? gDescs.length - 1 : item.level); i++) {
let group = gDescs[i].propertyName;
const val = item.items[0][group];
filters.push(`(${group} eq '${val}')`);
}
if (settings.filterBy && settings.filterBy.length > 0) {
filters.splice(0, 0, settings.filterBy);
}
if (filters.length > 0) {
settings.filterBy = filters.join(' and ');
}
if (!item.isBottomLevel)
settings.groupBy = item.groups[0].groupDescription.propertyName;
}
else
settings.groupBy = gDescs[0].propertyName;
}
// groupby definition for other cases
if (!this.groupLazyLoading) {
let _groupBy = [];
let _sortBy = [];
for (let i = 0; i < gDescs.length; i++) {
let _prop = gDescs[i].propertyName;
_groupBy.push(_prop);
_sortBy.push(`${_prop} ASC`);
}
settings.groupBy = _groupBy;
settings.sortBy = _sortBy.join(','); //sort the defined groups
}
}
// donot set groupby if request is not for groupItems
if (!groupInfo) {
delete settings.groupBy;
}
//update sortBy definition
if (this.sortDescriptions.length > 0) {
let _sortBy = [];
//check existing sort
if (settings.sortBy) {
_sortBy = settings.sortBy.split(',');
}
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
var _cSrtIdx = _sortBy.findIndex(x => x.indexOf(this.sortDescriptions[i].property) > -1);
if (_cSrtIdx > -1)
_sortBy[_cSrtIdx] = sort; // update existing sort
else
_sortBy.push(sort); // add new sort
}
settings.sortBy = _sortBy.join(',');
}
//skip and top for fetch data when virtualization is enabled
if (virtualParams && this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// for paginated data
if (this.pageOnServer && this.pageSize > 0 && !groupInfo) {
settings.skip = this.pageIndex * this.pageSize;
settings.top = (this.pageIndex * this.pageSize) + this.pageSize;
}
// set aggregates property if required (only with groupBy)
if (groupInfo && this.aggregates && this.aggregates.length > 0 && this.groupDescriptions.length > 0) {
settings.aggregates = this.aggregates;
}
// get specified fields only if set
if (this.fields && this.fields.length > 0 && !groupInfo) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
//fetch data
getItems(item) {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(item, false, true); // get data chunks if virtualization enabled
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; } // no pending requests
});
});
}
//fetch group items
getGroupItems(item) {
// cancel any pending requests
if (this._pendingRequest) {
this._pendingRequest.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(item, true, false); // request parameters for grouping
if (this.groupDescriptions.length > 0 && this.groupOnServer) {
httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let re = xhr.responseText;
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
this._totalGroupItemCount = asNumber(resp.totalGroupCount);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.groupItems);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
}
});
}
//#region Filter Implementation
// gets the OData like filter definition that accepts by datasource from a wijmo.grid.filter.FlexGridFilter object.
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import { FlexGrid, FlexGridColumn } from '@mescius/wijmo.react.grid';
import { FlexGridFilter } from '@mescius/wijmo.react.grid.filter';
import { RestGroupCollectionView } from './rest-group-collection-view';
import { createElement } from '@mescius/wijmo';
import './app.css';
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
function App() {
const [selectedFeature, setSelectedFeature] = useState('groupServer');
const [isReadOnly, setIsReadOnly] = useState(true);
const _isFirstLoad = useRef(true);
const flexRef = useRef(null);
const flexInitialized = (flexgrid) => {
flexRef.current = flexgrid;
//create RestGroupCollectionView instance
//with settings for default server grouping on first load
flexRef.current.itemsSource = new RestGroupCollectionView('purchaseorders', settings);
};
const settings = {
fields: fields,
virtualization: false,
groupLazyLoading: false,
groupDescriptions: ['State', 'City'],
loading: () => { toggleSpinner(flexRef.current, true); },
loaded: (s, e) => {
toggleSpinner(flexRef.current, false);
if (_isFirstLoad.current) {
_isFirstLoad.current = false;
// select first group row
setTimeout(() => {
flexRef.current.select(0, 0);
});
}
}
};
const toggleFeature = (feature) => {
setSelectedFeature(feature);
_isFirstLoad.current = true;
//default server group
if (feature == "groupServer") {
settings.virtualization = false;
settings.groupLazyLoading = false;
}
// enable virtualization
if (feature == "virtual") {
settings.virtualization = true;
settings.groupLazyLoading = false;
}
//enable group lazy loading
if (feature == "lazyload") {
settings.virtualization = false;
settings.groupLazyLoading = true;
}
// reset itemsSource
flexRef.current.itemsSource = new RestGroupCollectionView('purchaseorders', settings);
};
return (<div className="container-fluid">
<div id="feature-options">
<label htmlFor="groupServer">
<input id="groupServer" type="radio" name="feature" value="groupOnServer" checked={selectedFeature === 'groupServer'} onChange={() => toggleFeature('groupServer')}/>{' '}
Server Side Grouping
</label>
<br />
<label htmlFor="virtual">
<input id="virtual" type="radio" name="feature" value="virtualGrouping" onChange={() => toggleFeature('virtual')}/>{' '}
Server Side Grouping with virtualization
</label>
<br />
<label htmlFor="lazyload">
<input id="lazyload" type="radio" name="feature" value="lazyLoadGrouping" onChange={() => toggleFeature('lazyload')}/>{' '}
Server Side Grouping with group lazy-loading
</label>
</div>
<br />
<FlexGrid initialized={flexInitialized} isReadOnly={isReadOnly} autoGenerateColumns={false}>
<FlexGridFilter defaultFilterType="Condition"/>
<FlexGridColumn binding="OrderId" header="Order ID"/>
<FlexGridColumn binding="StockItem" header="Stock Item" width="*" minWidth={200}/>
<FlexGridColumn binding="Color" header="Color"/>
<FlexGridColumn binding="Quantity" header="Quantity" dataType="Number" format="n0"/>
<FlexGridColumn binding="UnitPrice" header="Unit Price" dataType="Number" format="n2"/>
<FlexGridColumn binding="Date" header="Date" dataType="Date" format="d"/>
<FlexGridColumn binding="IsChillerStock" header="Is Chiller Stock" dataType="Boolean"/>
</FlexGrid>
</div>);
}
//show gif loader while data loading
function toggleSpinner(grid, show) {
let _rect = grid.controlRect;
let elem = grid.hostElement.querySelector('.spinner');
if (!elem)
elem = createElement(`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`, grid.hostElement);
elem.style.display = show ? 'block' : 'none';
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
body {
margin-bottom: 36pt;
margin-top:10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner{
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top:40%;
left:45%;
}
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { DataType, DateTime, httpRequest, copy, changeType, isString, isDate, asNumber, isBoolean, } from '@mescius/wijmo';
import { RestCollectionView } from '@mescius/wijmo.rest';
// limit item count to fetch when virtualization or group lazy-loading is not enabled
const _MAXITEMCOUNT = 10000;
const _TableRecordCount = 231412; // total number of records available in DB for API.
// DataSource API
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestGroupCollectionView extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestGroupCollectionView} class to support ServerSide Grouping.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName, options) {
super(options);
this._url = _apiUrl;
this._pendingRequest = null;
this._tbl = tableName;
this.groupOnServer = true;
copy(this, options);
}
// parse data
_jsonReviver(key, value) {
// regex to parse date
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get request parameters to fetch data based on settings
_getReadParams(item, groupInfo = true, virtualParams = true) {
let gDescs = this.groupDescriptions;
let settings = {};
// #region Only required when ServerAPI limits top to 100 or other value
// load max _MAXITEMCOUNT items when virtualization is not enabled
if (!this.virtualization && this.groupOnServer) {
settings.top = _MAXITEMCOUNT;
}
// all available groups in-case of virtualization
if (this.virtualization && groupInfo && this.groupOnServer) {
settings.top = _MAXITEMCOUNT;
}
// load all available records from table for ServerSide GroupOnly case
if (this.groupOnServer && !this.virtualization && !this.groupLazyLoading && !groupInfo) {
settings.top = _TableRecordCount;
}
// #endRegion
// get filter definition
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
// get groupby defintion
if (this.groupOnServer && gDescs.length > 0) {
// groupby def for groupLazyloading feature
if (this.groupLazyLoading) {
if (item) {
let filters = [];
for (let i = 0; i <= (item.isBottomLevel ? gDescs.length - 1 : item.level); i++) {
let group = gDescs[i].propertyName;
const val = item.items[0][group];
filters.push(`(${group} eq '${val}')`);
}
if (settings.filterBy && settings.filterBy.length > 0) {
filters.splice(0, 0, settings.filterBy);
}
if (filters.length > 0) {
settings.filterBy = filters.join(' and ');
}
if (!item.isBottomLevel)
settings.groupBy = item.groups[0].groupDescription.propertyName;
}
else
settings.groupBy = gDescs[0].propertyName;
}
// groupby definition for other cases
if (!this.groupLazyLoading) {
let _groupBy = [];
let _sortBy = [];
for (let i = 0; i < gDescs.length; i++) {
let _prop = gDescs[i].propertyName;
_groupBy.push(_prop);
_sortBy.push(`${_prop} ASC`);
}
settings.groupBy = _groupBy;
settings.sortBy = _sortBy.join(','); //sort the defined groups
}
}
// donot set groupby if request is not for groupItems
if (!groupInfo) {
delete settings.groupBy;
}
//update sortBy definition
if (this.sortDescriptions.length > 0) {
let _sortBy = [];
//check existing sort
if (settings.sortBy) {
_sortBy = settings.sortBy.split(',');
}
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
var _cSrtIdx = _sortBy.findIndex(x => x.indexOf(this.sortDescriptions[i].property) > -1);
if (_cSrtIdx > -1)
_sortBy[_cSrtIdx] = sort; // update existing sort
else
_sortBy.push(sort); // add new sort
}
settings.sortBy = _sortBy.join(',');
}
//skip and top for fetch data when virtualization is enabled
if (virtualParams && this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// for paginated data
if (this.pageOnServer && this.pageSize > 0 && !groupInfo) {
settings.skip = this.pageIndex * this.pageSize;
settings.top = (this.pageIndex * this.pageSize) + this.pageSize;
}
// set aggregates property if required (only with groupBy)
if (groupInfo && this.aggregates && this.aggregates.length > 0 && this.groupDescriptions.length > 0) {
settings.aggregates = this.aggregates;
}
// get specified fields only if set
if (this.fields && this.fields.length > 0 && !groupInfo) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
//fetch data
getItems(item) {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(item, false, true); // get data chunks if virtualization enabled
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; } // no pending requests
});
});
}
//fetch group items
getGroupItems(item) {
// cancel any pending requests
if (this._pendingRequest) {
this._pendingRequest.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(item, true, false); // request parameters for grouping
if (this.groupDescriptions.length > 0 && this.groupOnServer) {
httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let re = xhr.responseText;
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
this._totalGroupItemCount = asNumber(resp.totalGroupCount);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.groupItems);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
}
});
}
//#region Filter Implementation
// gets the OData like filter definition that accepts by datasource from a wijmo.grid.filter.FlexGridFilter object.
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
}
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<div class="row">
<div id="feature-options" class="col-sm-6">
<label for="lazyload">
<input id="lazyload" type="radio" name="feature" value="lazyLoadGrouping" checked
@change="toggleFeature('lazyload')" />
Server Side Grouping with group lazy-loading
</label>
<br />
<label for="groupServer">
<input id="groupServer" type="radio" name="feature" value="groupOnServer"
@change="toggleFeature('groupServer')" />
Server Side Grouping
</label>
<br />
<label for="virtual">
<input id="virtual" type="radio" name="feature" value="virtualGrouping"
@change="toggleFeature('virtual')" />
Server Side Grouping with virtualization
</label>
</div>
<div class="col-sm-6">
<label for="paging">
Paging
<input ref="inpCbRef" id='paging' type="checkbox" checked @change="toggleFeature('paging')" >
</label>
</div>
</div>
<wj-collection-view-navigator :cv="view" :byPage="true"
:initialized="pagerInitialized"></wj-collection-view-navigator>
<wj-flex-grid :initialized="flexInitialized" :itemsSource="view" :isReadOnly="isReadOnly"
:autoGenerateColumns="false">
<wj-flex-grid-filter :defaultFilterType="'Condition'" />
<wj-flex-grid-column binding="OrderId" header="Order ID" />
<wj-flex-grid-column binding="StockItem" header="Stock Item" :width="'*'" :minWidth="200" />
<wj-flex-grid-column binding="Color" header="Color" />
<wj-flex-grid-column binding="Quantity" header="Quantity" :dataType="'Number'" format="n0" />
<wj-flex-grid-column binding="UnitPrice" header="Unit Price" :dataType="'Number'" format="n2" />
<wj-flex-grid-column binding="Date" header="Date" :dataType="'Date'" format="d" />
<wj-flex-grid-column binding="IsChillerStock" header="Is Chiller Stock" :dataType="'Boolean'" />
</wj-flex-grid>
</div>
</template>
<script setup>
import { RestGroupCollectionView } from "./rest-group-collection-view";
import { ref } from "vue";
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
const inpCbRef = ref(null);
const isReadOnly = ref(true);
const _isFirstLoad = ref(true);
const settings = {
fields: fields,
virtualization: false,
groupLazyLoading: true,
groupDescriptions: ["State", "City"],
pageSize: 10,
loading: () => {
toggleSpinner(flexGrid.value, true);
},
loaded: (s, e) => {
toggleSpinner(flexGrid.value, false);
if (_isFirstLoad.value) {
_isFirstLoad.value = false;
// select first group row
setTimeout(() => {
flexGrid.value.select(0, 0);
});
}
},
};
const view = ref(null);
const flexGrid = ref(null);
const pager = ref(null);
//create RestGroupCollectionView instance
//with settings for default server grouping on first load
view.value = new RestGroupCollectionView('purchaseorders', settings);
function pagerInitialized(pagerCtrl){
pager.value = pagerCtrl;
}
function flexInitialized(grid) {
flexGrid.value = grid;
}
function toggleFeature(feature) {
const pageChecker = inpCbRef.value;
_isFirstLoad.value = true;
if (feature === "groupServer") {
settings.virtualization = false;
settings.groupLazyLoading = false;
} else if (feature === "virtual") {
settings.virtualization = true;
settings.groupLazyLoading = false;
if (!shouldPagingEnabled(settings, pageChecker.checked)) {
pageChecker.checked = false;
pager.value.hostElement.style.display = pageChecker.checked ? "inline-flex" : "none";
alert("Paging cannot be enabled with Virtualization!");
}
} else if (feature === "lazyload") {
settings.virtualization = false;
settings.groupLazyLoading = true;
}
if(feature === "paging"){
if (!shouldPagingEnabled(settings, pageChecker.checked)) {
pageChecker.checked = false;
alert("Paging cannot be enabled with Virtualization!");
return;
}
settings.pageSize = pageChecker.checked ? 10 : 0;
pager.value.hostElement.style.display = pageChecker.checked ? "inline-flex" : "none";
}
const cv = new RestGroupCollectionView("purchaseorders", settings);
flexGrid.value.itemsSource = cv;
pager.value.cv = cv;
}
function shouldPagingEnabled(settings, paging) {
if (settings.virtualization && paging) {
settings.pageSize = 0;
return false;
}
return true;
}
//show gif loader while data loading
function toggleSpinner(grid, show) {
let _rect = grid.controlRect;
let elem = grid.hostElement.querySelector(".spinner");
if (!elem) elem = wijmo.createElement(`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`, grid.hostElement);
elem.style.display = show ? "block" : "none";
}
</script>
<style>
body {
margin-bottom: 36pt;
margin-top: 10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner {
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top: 40%;
left: 45%;
}
label{
padding: 0 10px;
}
.wj-pager{
margin-bottom: 5px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { DataType, DateTime, httpRequest, copy, changeType, isString, isDate, asNumber, isBoolean, } from '@mescius/wijmo';
import { RestCollectionView } from '@mescius/wijmo.rest';
// limit item count to fetch when virtualization or group lazy-loading is not enabled
const _MAXITEMCOUNT = 10000;
// DataSource API
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestGroupCollectionView extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestGroupCollectionView} class to support ServerSide Grouping.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName, options) {
super(options);
this._url = _apiUrl;
this._pendingRequest = null;
this._tbl = tableName;
this.groupOnServer = true;
copy(this, options);
}
// parse data
_jsonReviver(key, value) {
// regex to parse date
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get request parameters to fetch data based on settings
_getReadParams(item, groupInfo = true, virtualParams = true) {
let gDescs = this.groupDescriptions;
let settings = {};
// #region Only required when ServerAPI limits top to 100 or other value
settings.limit = 50000; // consider max items available is 50K
// load max _MAXITEMCOUNT items when virtualization is not enabled
if (!this.virtualization && this.groupOnServer) {
settings.top = _MAXITEMCOUNT;
}
// all available groups in-case of virtualization
if (this.virtualization && groupInfo && this.groupOnServer) {
settings.top = _MAXITEMCOUNT;
}
// #endRegion
// get filter definition
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
// get groupby defintion
if (this.groupOnServer && gDescs.length > 0) {
// groupby def for groupLazyloading feature
if (this.groupLazyLoading) {
if (item) {
let filters = [];
for (let i = 0; i <= (item.isBottomLevel ? gDescs.length - 1 : item.level); i++) {
let group = gDescs[i].propertyName;
const val = item.items[0][group];
filters.push(`(${group} eq '${val}')`);
}
if (settings.filterBy && settings.filterBy.length > 0) {
filters.splice(0, 0, settings.filterBy);
}
if (filters.length > 0) {
settings.filterBy = filters.join(' and ');
}
if (!item.isBottomLevel)
settings.groupBy = item.groups[0].groupDescription.propertyName;
}
else
settings.groupBy = gDescs[0].propertyName;
}
// groupby definition for other cases
if (!this.groupLazyLoading) {
let _groupBy = [];
let _sortBy = [];
for (let i = 0; i < gDescs.length; i++) {
let _prop = gDescs[i].propertyName;
_groupBy.push(_prop);
_sortBy.push(`${_prop} ASC`);
}
settings.groupBy = _groupBy;
settings.sortBy = _sortBy.join(','); //sort the defined groups
}
}
// donot set groupby if request is not for groupItems
if (!groupInfo) {
delete settings.groupBy;
}
//update sortBy definition
if (this.sortDescriptions.length > 0) {
let _sortBy = [];
//check existing sort
if (settings.sortBy) {
_sortBy = settings.sortBy.split(',');
}
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
var _cSrtIdx = _sortBy.findIndex(x => x.indexOf(this.sortDescriptions[i].property) > -1);
if (_cSrtIdx > -1)
_sortBy[_cSrtIdx] = sort; // update existing sort
else
_sortBy.push(sort); // add new sort
}
settings.sortBy = _sortBy.join(',');
}
//skip and top for fetch data when virtualization is enabled
if (virtualParams && this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// for paginated data
if (!this.virtualization && this.pageOnServer && this.pageSize > 0 && ((!groupInfo && !this.groupLazyLoading) || (this.groupLazyLoading && !item))) {
settings.skip = this.pageIndex * this.pageSize;
settings.top = this.pageSize;
}
// set aggregates property if required (only with groupBy)
if (groupInfo && this.aggregates && this.aggregates.length > 0 && this.groupDescriptions.length > 0) {
settings.aggregates = this.aggregates;
}
// get specified fields only if set
if (this.fields && this.fields.length > 0 && !groupInfo) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
//fetch data
getItems(item) {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(item, false, true); // get data chunks if virtualization enabled
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; } // no pending requests
});
});
}
//fetch group items
getGroupItems(item) {
// cancel any pending requests
if (this._pendingRequest) {
this._pendingRequest.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(item, true, false); // request parameters for grouping
if (this.groupDescriptions.length > 0 && this.groupOnServer) {
httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let re = xhr.responseText;
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
if ((this.groupOnServer && !this.groupLazyLoading) || (this.groupLazyLoading && !item)) {
this._totalGroupItemCount = asNumber(resp.totalGroupCount);
}
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.groupItems);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
}
});
}
//#region Filter Implementation
// gets the OData like filter definition that accepts by datasource from a wijmo.grid.filter.FlexGridFilter object.
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, enableProdMode, ChangeDetectorRef, ɵresolveComponentResources, ViewChild } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjGridFilterModule } from '@mescius/wijmo.angular2.grid.filter';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { RestGroupCollectionView } from './rest-group-collection-view';
import { FlexGrid } from '@mescius/wijmo.grid';
import { createElement } from '@mescius/wijmo';
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
@Component({
standalone: true,
imports: [WjGridModule, WjGridFilterModule, WjInputModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
isReadOnly = true;
private _firstLoad = true;
cvSettings = {
virtualization: false,
groupLazyLoading: false,
fields: fields,
groupDescriptions: ['State', 'City'],
loading: () => {
this.toggleSpinner(this._flexGrid, true);
},
loaded: (s: RestGroupCollectionView, e: any) => {
this.toggleSpinner(this._flexGrid, false);
if (this._firstLoad) {
this._firstLoad = false;
// select first group row
setTimeout(() => {
this._flexGrid.select(0, 0);
});
}
},
};
//create RestGroupCollectionView instance
//with settings for default server grouping on first load
view = new RestGroupCollectionView('purchaseorders', this.cvSettings);
@ViewChild('theGrid', { static: true }) private _flexGrid: FlexGrid;
constructor(private readonly _chDetector: ChangeDetectorRef) {}
//show gif loader while data loading
toggleSpinner(grid: FlexGrid, show: boolean) {
let _rect = grid.controlRect;
let elem: HTMLElement = grid.hostElement.querySelector('.spinner');
if (!elem)
elem = createElement(
`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`,
grid.hostElement,
);
elem.style.display = show ? 'block' : 'none';
}
toggleFeature(feature: string) {
this._firstLoad = true;
//default server grouping
if (feature == 'groupServer') {
this.cvSettings.virtualization = false;
this.cvSettings.groupLazyLoading = false;
}
// enable virtualization
if (feature == 'virtual') {
this.cvSettings.virtualization = true;
this.cvSettings.groupLazyLoading = false;
}
//enable group lazy loading
if (feature == 'lazyload') {
this.cvSettings.virtualization = false;
this.cvSettings.groupLazyLoading = true;
}
// reset itemsSource
this._flexGrid.itemsSource = new RestGroupCollectionView('purchaseorders', this.cvSettings);
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div id="feature-options">
<label for="groupServer">
<input id="groupServer" type="radio" name="feature" value="groupOnServer" checked (change)="toggleFeature('groupServer')"> Server Side Grouping
</label>
<br>
<label for="virtual">
<input id="virtual" type="radio" name="feature" value="virtualGrouping" (change)="toggleFeature('virtual')"> Server Side Grouping with
virtualization
</label>
<br>
<label for="lazyload">
<input id="lazyload" type="radio" name="feature" value="lazyLoadGrouping" (change)="toggleFeature('lazyload')"> Server Side Grouping with group
lazy-loading
</label>
</div>
<br />
<wj-flex-grid #theGrid [isReadOnly]="isReadOnly" [itemsSource]="view" [autoGenerateColumns]="false">
<wj-flex-grid-filter [filterType]="'Condition'"></wj-flex-grid-filter>
<wj-flex-grid-column binding="OrderId" header="Order ID" />
<wj-flex-grid-column binding="StockItem" header="Stock Item" [width]="'*'" [minWidth]="200" />
<wj-flex-grid-column binding="Color" header="Color" />
<wj-flex-grid-column binding="Quantity" header="Quantity" [dataType]="'Number'" format="n0" />
<wj-flex-grid-column binding="UnitPrice" header="Unit Price" [dataType]="'Number'" format="n2" />
<wj-flex-grid-column binding="Date" header="Date" [dataType]="'Date'" format="d" />
<wj-flex-grid-column binding="IsChillerStock" header="Is Chiller Stock" [dataType]="'Boolean'" />
</wj-flex-grid>
</div>
body {
margin-bottom: 36pt;
margin-top:10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner{
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top:40%;
left:45%;
}
import {
DataType, DateTime, PropertyGroupDescription, CollectionViewGroup,
httpRequest, copy, changeType, isString, isDate, asNumber, isBoolean,
} from '@mescius/wijmo';
import { RestCollectionView } from '@mescius/wijmo.rest';
// limit item count to fetch when virtualization or group lazy-loading is not enabled
const _MAXITEMCOUNT = 10000;
const _TableRecordCount = 231412; // total number of records available in DB for API.
// DataSource API
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestGroupCollectionView extends RestCollectionView {
private _url: string = _apiUrl;
private _tbl: string; // table name or API endpoint
/**
* Initializes a new instance of the {@link RestGroupCollectionView} class to support ServerSide Grouping.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName: string, options?: any) {
super(options);
this._tbl = tableName;
this.groupOnServer = true;
copy(this, options);
}
// parse data
private _jsonReviver(key: string, value: any): any {
// regex to parse date
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get request parameters to fetch data based on settings
_getReadParams(item?: CollectionViewGroup, groupInfo: boolean = true, virtualParams: boolean = true): any {
let gDescs = this.groupDescriptions;
let settings: any = {};
// #region Only required when ServerAPI limits top to 100 or other value
// load max _MAXITEMCOUNT items when virtualization is not enabled
if (!this.virtualization && this.groupOnServer) {
settings.top = _MAXITEMCOUNT;
}
// all available groups in-case of virtualization
if(this.virtualization && groupInfo && this.groupOnServer){
settings.top = _MAXITEMCOUNT;
}
// load all available records from table for ServerSide GroupOnly case
if(this.groupOnServer && !this.virtualization && !this.groupLazyLoading && !groupInfo){
settings.top= _TableRecordCount;
}
// #endRegion
// get filter definition
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
// get groupby defintion
if (this.groupOnServer && gDescs.length > 0) {
// groupby def for groupLazyloading feature
if (this.groupLazyLoading) {
if (item) {
let filters = []
for (let i = 0; i <= (item.isBottomLevel ? gDescs.length - 1 : item.level); i++) {
let group = (gDescs[i] as PropertyGroupDescription).propertyName;
const val = item.items[0][group];
filters.push(`(${group} eq '${val}')`);
}
if (settings.filterBy && settings.filterBy.length > 0) {
filters.splice(0, 0, settings.filterBy);
}
if (filters.length > 0) {
settings.filterBy = filters.join(' and ');
}
if (!item.isBottomLevel)
settings.groupBy = (item.groups[0].groupDescription as PropertyGroupDescription).propertyName;
} else
settings.groupBy = (gDescs[0] as PropertyGroupDescription).propertyName;
}
// groupby definition for other cases
if (!this.groupLazyLoading) {
let _groupBy = [];
let _sortBy = [];
for (let i = 0; i < gDescs.length; i++) {
let _prop = (gDescs[i] as PropertyGroupDescription).propertyName;
_groupBy.push(_prop);
_sortBy.push(`${_prop} ASC`);
}
settings.groupBy = _groupBy;
settings.sortBy = _sortBy.join(','); //sort the defined groups
}
}
// donot set groupby if request is not for groupItems
if (!groupInfo) {
delete settings.groupBy;
}
//update sortBy definition
if (this.sortDescriptions.length > 0) {
let _sortBy: string[] = [];
//check existing sort
if (settings.sortBy) {
_sortBy = settings.sortBy.split(',');
}
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort: string = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
var _cSrtIdx = _sortBy.findIndex(x => x.indexOf(this.sortDescriptions[i].property) > -1);
if (_cSrtIdx > -1)
_sortBy[_cSrtIdx] = sort; // update existing sort
else
_sortBy.push(sort);// add new sort
}
settings.sortBy = _sortBy.join(',');
}
//skip and top for fetch data when virtualization is enabled
if (virtualParams && this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// for paginated data
if (this.pageOnServer && this.pageSize > 0 && !groupInfo) {
settings.skip = this.pageIndex * this.pageSize;
settings.top = (this.pageIndex * this.pageSize) + this.pageSize;
}
// set aggregates property if required (only with groupBy)
if (groupInfo && this.aggregates && this.aggregates.length > 0 && this.groupDescriptions.length > 0) {
settings.aggregates = this.aggregates;
}
// get specified fields only if set
if (this.fields && this.fields.length > 0 && !groupInfo) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
//fetch data
protected getItems(item?: CollectionViewGroup): Promise<any[]> {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise<any>(resolve => {
let _settings = this._getReadParams(item, false, true); // get data chunks if virtualization enabled
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: async xhr => {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
},
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; }// no pending requests
});
});
}
_pendingRequest: XMLHttpRequest = null;
//fetch group items
protected getGroupItems(item?: CollectionViewGroup): Promise<any[]> {
// cancel any pending requests
if (this._pendingRequest) {
this._pendingRequest.abort();
}
return new Promise<any>(resolve => {
let _settings = this._getReadParams(item, true, false); // request parameters for grouping
if (this.groupDescriptions.length > 0 && this.groupOnServer) {
httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: async xhr => {
// parse response
let re = xhr.responseText;
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
this._totalGroupItemCount = asNumber(resp.totalGroupCount);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.groupItems);
},
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
}
});
}
//#region Filter Implementation
// gets the OData like filter definition that accepts by datasource from a wijmo.grid.filter.FlexGridFilter object.
_asODataFilter(filter: any): string {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c],
cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
} else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf: any): string {
let col = vf.column,
fld = col.binding,
map = col.dataMap,
def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def) def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld: string, value: any, type: DataType): string {
let def = '',
DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
} else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
} else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf: any): string {
let c1 = this._asODataCondition(cf, cf.condition1),
c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2) return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1) return '(' + c1 + ')';
if (c2) return '(' + c2 + ')';
return null;
}
_asODataCondition(cf: any, cnd: any): string {
let col = cf.column,
fld = col.binding,
map = col.dataMap,
value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value: any, dataType: DataType): string {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
} else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
} else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
//#endRegion
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);